#!/bin/bash
set -e
set -x

shopt -s extglob

# Check for leftover directories/files from Mac OS X/Windows
# and warn the user

# FIXME: Ensure that this runs before greeter
# look how enable persistence is determined and replicate?

# In case we want to customize the message in the future..

# Mac OSX:
# http://www.westwind.com/reference/OS-X/invisibles.html
macosx_dirs="__MACOSX .fseventsd .TemporaryItems ._Temporary\ Items .Trashes Temporary\ Items Volumes"
macosx_files="._ .AppleDouble .com.apple.timemachine.donotpresent \
    .com.apple.timemachine.supported .DocumentRevisions-V100 .DS_Store .hidden \
    .LSOverride .metadata_never_index .Spotlight-V100"

## Mac OSX dirs:

for dir in $macosx_dirs
do
    extended_dir="-iname $dir -o"
    macosx_extended_dirsline="$extended_dir $macosx_extended_dirsline"
done

# Remove extraneous -o at the end:
# FIXME: Ugly, but works. Couldn't get a working sed:
macosx_extended_dirsline="$(echo $macosx_extended_dirsline | awk '{$NF="";sub(/[ \t]+$/,"")}1')"

## Mac OSX files:

for file in $macosx_files
do
    extended_file="-iname $file -o"
    macosx_extended_filesline="$extended_file $macosx_extended_filesline"
done

# Remove extraneous -o at the end:
# FIXME: Ugly, but works. Couldn't get a working sed:
macosx_extended_filesline="$(echo $macosx_extended_filesline | awk '{$NF="";sub(/[ \t]+$/,"")}1')"

# Windows:
# https://stackoverflow.com/questions/15835213/list-of-various-system-files-safe-to-ignore-when-implementing-a-virtual-file-sys
windows_dirs="\$RECYCLE.BIN"
windows_files="AlbumArt*.jpg Desktop.ini ehthumbs.db Folder.jpg Thumbs.db"

## Windows dirs:
for dir in $windows_dirs
do
    extended_dir="-iname $dir -o"
    windows_extended_dirsline="$extended_dir $windows_extended_dirsline"
done

# Remove extraneous -o at the end:
# FIXME: Ugly, but works. Couldn't get a working sed:
windows_extended_dirsline="$(echo $windows_extended_dirsline | awk '{$NF="";sub(/[ \t]+$/,"")}1')"

windows_dirs_output="$(find . -type f $windows_extended_dirsline)"

## Windows files:

for file in $windows_files
do
    extended_file="-iname $file -o"
    windows_extended_filesline="$extended_file $windows_extended_filesline"
done

# Remove extraneous -o at the end:
# FIXME: Ugly, but works. Couldn't get a working sed:
windows_extended_filesline="$(echo $windows_extended_filesline | awk '{$NF="";sub(/[ \t]+$/,"")}1')"

macosx_dirs_output="$(find . -type d $macosx_extended_dirsline | tr '\n' ' ')"
macosx_files_output="$(find . -type f $macosx_extended_filesline | tr '\n' ' ')"
windows_dirs_output="$(find . -type d $windows_extended_dirsline | tr '\n' ' ')"
windows_files_output="$(find . -type f $windows_extended_filesline | tr '\n' ' ')"

output="${macosx_dirs_output} ${macosx_files_output} ${windows_dirs_output} ${windows_files_output}"

if [[ ! -z ${output##*( )} ]] ; then
    # FIXME: Warn aggressively here, in the GUI instead of to stdout:
    echo "This drive appears to have been used with Windows and/or Mac OSX, it cannot be considered trusted."
    echo "These files were found: $output"
else
    echo "No garbage found, good job :)"
fi

# FIXME: detect hidden partitions, warn for that as well.

